Raul::PathTable< T > Class Template Reference
Realtime Audio Utility Library

Table of Paths. More...

`#include <PathTable.hpp>`

Inheritance diagram for Raul::PathTable< T >:
Collaboration diagram for Raul::PathTable< T >:

## Public Member Functions

Table< Path, T >::iterator | find_descendants_end (typename Table< Path, T >::iterator parent)
| Find all descendants of a Path key in the Table. More...
Table< Path, T >::const_iterator | find_descendants_end (typename Table< Path, T >::const_iterator parent) const
Public Member Functions inherited from Raul::Table< Path, T >
| Table (size_t capacity)
void | clear ()
bool | empty () const
void | reserve (size_t n)
size_t | size () const
std::pair< iterator, bool > | insert (const std::pair< Path, T > &entry)
| Add an item to the table, using entry.first as the search key. More...
void | erase (const Path &key)
void | erase (iterator i)
void | erase (iterator start, iterator end)
| Erase a range of elements from first to last, including first but not including last.
void | erase_by_index (size_t start, size_t end)
| Erase a range of elements from first_index to last_index, including first_index but not including last_index.
SharedPtr< Table< Path, T > > | yank (iterator start, iterator end)
| Erase and return a range of entries.
std::pair< iterator, bool > | cram (const Table< Path, T > &range)
| Cram a range of entries back in. More...
const_iterator | find (const_iterator start, const_iterator end, const Path &key) const
| Binary search (O(log(end - start)))
const_iterator | find (const Path &key) const
| Binary search (O(log(n)))
iterator | find (const_iterator start, const_iterator end, const Path &key)
| Binary search (O(log(end - start)))
iterator | find (const Path &key)
| Binary search (O(log(n)))
const_iterator | find_range_end (const_iterator left, bool(*comp)(const Path &, const Path &)) const
| Find the end of a range using a custom comparator. More...
iterator | find_range_end (iterator left, bool(*comp)(const Path &, const Path &))
| Find the end of a range using a custom comparator. More...
T & | operator[] (const Path &key)
| Insert an item, and return a reference to it's value. More...
const_iterator | begin () const
iterator | begin ()
const_iterator | end () const
iterator | end ()

## Detailed Description

### template<typename T>
class Raul::PathTable< T >

Table of Paths.

## Member Function Documentation

template<typename T >

Table<Path, T>::iterator Raul::PathTable< T >::find_descendants_end | ( | typename Table< Path, T >::iterator | parent | ) |

inline

Find all descendants of a Path key in the Table.

It is guaranteed that (parent, parent+1, parent+2, ..., ret-1) are all descendants of parent. The return value is never a descendent of parent, and may be end().

References Raul::Path::descendant_comparator(), and Raul::Table< Path, T >::find_range_end().

The documentation for this class was generated from the following file:

- PathTable.hpp